# Dissertation: Information Collector Component

*This repository is part of the three components that make my personal Dissertation.*

## Main objectives
Expose a RESTFull API to gather all grid members' information, such as IP, numbers of CPUs, Load average, and more.
  
## How to install
Firs of all, download the project and cd in:

```bash
$ git clone git@bitbucket.org:aramirez/dissertation-information-collector.git
$ cd dissertation-information-collector
```

As this project uses Vagrant and Ansible to be able to working in a virtual machine besides deploy the project to production, you need to install both [Vagrant](https://www.vagrantup.com/downloads.html) and [Ansible](http://docs.ansible.com/intro_installation.html).

Once you have installed Ansible, you should install a few Ansible components:

```bash
$ ansible-galaxy install aramirez-es.common
$ ansible-galaxy install aramirez-es.apache-php
$ ansible-galaxy install Stouts.mongodb
$ ansible-galaxy install carlosbuenosvinos.ansistrano-deploy
```

Finally, run vagrant in order to create the virtual machine:

```bash
$ vagrant up
```

Then, ssh to the machine and install the dependencies:
 
```bash
$ vagrant ssh
$ curl -sS https://getcomposer.org/installer | php -- --install-dir=/usr/bin --filename=composer
$ cd /var/www/api.pfc.aramirez.es/current
$ composer install
```

## Launch 
As you have the virtual machine running, you can open your browser and type this url ```https://192.168.50.101/```. That url should return a response like:

```json
{"systems":"https://192.168.50.101/systems"}
```

## Run the tests
Inside the virtual machine, in the project path, just run:

```bash
$ bin/phpspec run --format=pretty
```