<?php

namespace spec\Collector\Core;

use PhpSpec\ObjectBehavior;
use Prophecy\Argument;

class HealthCheckSpec extends ObjectBehavior
{
    function let()
    {
        $this->beSuccessfullyConstructed();
    }

    function it_should_expose_its_id()
    {
        $this->id()->shouldBe("id");
    }

    function it_should_expose_created_at()
    {
        $this->createdAt()->shouldHaveType('\DateTimeImmutable');
    }

    function it_should_expose_cpu_load()
    {
        $this->cpuLoad()->shouldBe(1.23);
    }

    function it_should_expose_cpu_load_as_float_always()
    {
        $this->beWronglyConstructed();
        $this->cpuLoad()->shouldBe(0.00);
    }

    function it_should_expose_used_ram()
    {
        $this->usedRam()->shouldBe(543.56);
    }

    function it_should_expose_used_ram_as_float_always()
    {
        $this->beWronglyConstructed();
        $this->usedRam()->shouldBe(0.00);
    }

    function it_should_expose_used_hdd()
    {
        $this->usedHdd()->shouldBe(2013.53);
    }

    function it_should_expose_used_hdd_as_float_always()
    {
        $this->beWronglyConstructed();
        $this->usedHdd()->shouldBe(0.00);
    }

    private function beSuccessfullyConstructed()
    {
        $this->beConstructedWith('id', 1.23, 543.56, 2013.53);
    }

    private function beWronglyConstructed()
    {
        $this->beConstructedWith('id', 'awq', 'sasasa', 'wdaa');
    }
}
