<?php

namespace Collector\Core\HealthCheck;

use Collector\Core\HealthCheck;
use Collector\Core\System\Id;

class Service
{
    private $healthchecks = [];

    public function __construct(Repository $healthchecks)
    {
        $this->healthchecks = $healthchecks;
    }

    public function register(HealthCheck $current_health)
    {
        $this->healthchecks->add($current_health);
    }

    public function display()
    {
        return $this->healthchecks->findAll();
    }

    public function retrieve($system_id)
    {
        return $this->healthchecks->findById(new Id($system_id));
    }
}
