<?php

namespace Collector\Core\System;

class Collection extends \ArrayIterator implements \JsonSerializable
{
    /**
     * (PHP 5 &gt;= 5.4.0)<br/>
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     */
    public function jsonSerialize()
    {
        $accumulated = [];
        foreach ($this as $item) {
            $accumulated[] = $item->jsonSerialize();
        }
        return $accumulated;
    }
}
