<?php

namespace Collector\Core\System;

use Collector\Core\System;

class Service
{
    private $system_collection;

    public function __construct(Repository $system_collection)
    {
        $this->system_collection = $system_collection;
    }

    public function create(System $system)
    {
        $this->system_collection->add($system);
    }

    public function get()
    {
        return $this->system_collection->findAll();
    }

    public function retrieve($system_id)
    {
        return $this->system_collection->findById(new Id($system_id)) ?: null;
    }

    public function replace($system_id, System $new_system)
    {
        if ($system_id !== $new_system->id()) {
            throw new \DomainException('You cannot send two different ids');
        }
        $this->system_collection->update(new Id($system_id), $new_system);
    }

    public function delete($system_id)
    {
        $system_id = new Id($system_id);
        if (!$this->retrieve($system_id->getId())) {
            throw new \InvalidArgumentException("$system_id does not exist.");
        }
        $this->system_collection->delete($system_id);
    }
}
