<?php
/**
 * Created by PhpStorm.
 * User: alberto.ramirez
 * Date: 14/5/15
 * Time: 20:17
 */

namespace Collector\Infrastructure;

use Collector\Core\HealthCheck;
use Collector\Core\HealthCheck\Repository;
use Collector\Core\HealthCheck\Collection;
use Collector\Core\System\Id;

class HealthCheckInMemory implements Repository
{
    private $collection;

    public function __construct()
    {
        $this->collection = new \ArrayIterator();
    }

    public function add(HealthCheck $current)
    {
        $this->collection->append($current);
    }

    public function findAll()
    {
        return new Collection($this->collection);
    }

    public function findById(Id $system_id)
    {
        return new Collection(
            array_filter($this->collection->getArrayCopy(), function(HealthCheck $item) use ($system_id) {
                return $item->id() === $system_id->getId();
            })
        );
    }


}