<?php

namespace Collector\Infrastructure;

use Collector\Core\System;
use Collector\Core\System\Collection;
use Collector\Core\System\Repository;

class SystemInMemory implements Repository
{
    private $system_collection;

    public function __construct()
    {
        $this->system_collection = new \ArrayIterator();
    }

    public function add(System $system)
    {
        $this->system_collection[$system->id()] = $system;
    }

    public function findAll()
    {
        return new Collection($this->system_collection);
    }

    public function findById(System\Id $system_id)
    {
        return isset($this->system_collection[$system_id->getId()])
            ? $this->system_collection[$system_id->getId()]
            : null;
    }

    public function update(System\Id $system_id, System $new_system)
    {
        $this->add(
            new System(
                $system_id,
                $new_system->hostname(),
                $new_system->ip(),
                $new_system->numberOfCpus(),
                $new_system->ramCapacity(),
                $new_system->hddCapacity(),
                $new_system->OperatingSystem()
            )
        );
    }

    public function delete(System\Id $system_id)
    {
        unset($this->system_collection[$system_id->getId()]);
    }
}