<?php
$app->register(new Silex\Provider\UrlGeneratorServiceProvider());
$app->register(new Silex\Provider\TwigServiceProvider());
$app['twig'] = $app->share($app->extend('twig', function($twig, $app) {
    $app['twig.loader.filesystem']->addPath(__DIR__ . '/../templates', 'frontend');
    $twig->addExtension(new Twig_Extensions_Extension_Date());

    return $twig;
}));

$app->register(new Silex\Provider\DoctrineServiceProvider());
$app->register(new Silex\Provider\SecurityServiceProvider());
$app->register(new Silex\Provider\RememberMeServiceProvider());
$app->register(new Silex\Provider\SessionServiceProvider());
$app->register(new Silex\Provider\ServiceControllerServiceProvider());
$app->register(new Silex\Provider\SwiftmailerServiceProvider());
$userServiceProvider = new SimpleUser\UserServiceProvider();
$app->register($userServiceProvider);
$app->mount('/user', $userServiceProvider);

/**
 * Override some routes.
 */
$app->get('/user/{id}', function() use ($app) {
    return $app->redirect($app['url_generator']->generate('homepage'));
})->bind('user.view');

$app['user.options'] = [

    'templates' => [
        'login' => '@frontend/users/login.twig',
        'register' => '@frontend/users/register.twig',
        'forgot-password' => '@frontend/users/forgot-password.twig',
        'login-confirmation-needed' => '@frontend/users/login-confirmation-needed.twig',
        'register-confirmation-sent' => '@frontend/users/register-confirmation-sent.twig',
        'reset-password' => '@frontend/users/reset-password.twig',
        'list' => '@frontend/users/list.twig',
        'edit' => '@frontend/users/edit.twig',
    ],

    'emailConfirmation' => [
        'required' => true
    ],

    'mailer' => [
        'enabled' => true,
        'fromEmail' => [
            'address' => 'adminpfc@aramirez.es',
            'name' => 'Grid Admin Panel',
        ],
    ],
];

$app['security.firewalls'] = [
    'secured_area' => [
        'pattern' => '^.*$',
        'anonymous' => true,
        'remember_me' => [],
        'form' => [
            'login_path' => '/user/login',
            'check_path' => '/user/login_check',
        ],
        'logout' => [
            'logout_path' => '/user/logout',
        ],
        'users' => $app->share(function($app) { return $app['user.manager']; }),
    ],
];

$app['security.access_rules'] = [
    ['^/?$', 'ROLE_USER'],
    ['^/systems/.*$', 'ROLE_ADMIN'],
    ['^/user/list$', 'ROLE_ADMIN'],
    ['^/user/roles$', 'ROLE_ADMIN'],
];

$app['swiftmailer.options'] = [
    'host' => 'mail.aramirez.es',
    'port' => '587',
    'username' => 'adminpfc@aramirez.es',
    'password' => 'i3U6AAb$e;Qb',
];

$app['db.options'] = [
    'driver'   => 'pdo_mysql',
    'host' => 'localhost',
    'dbname' => 'users',
    'user' => 'userforusersdb',
    'password' => 'eiaBXd+98J(t',
];

$app['http_client'] = function() {
    return new GuzzleHttp\Client([]);
};

$app['http_client.default_config'] = [
    'timeout' => 2,
    'verify' => __DIR__ . '/../ssl/ca.cert.pem'
];

/**
 * Information-Collector endpoints.
 */
$app['information_collector.endpoints'] = [
    'home'          => 'https://api.pfc.aramirez.es/',
    'systems'       => 'https://api.pfc.aramirez.es/systems',
    'system_by_id'  => 'https://api.pfc.aramirez.es/systems/{systems_id}',
    'healths'       => 'https://api.pfc.aramirez.es/systems/{systems_id}/healths',
];