<?php

$app = new Silex\Application();

/**
 * Hack to redirect logged in users to homepage when they go to either "login" or "register" pages.
 *
 * This hack is needed since both pages are managed by external plugin.
 */
$app->before(function(\Symfony\Component\HttpFoundation\Request $request) use ($app) {
    $isLoggedIn = !empty($app['user']);
    $pathsToDoNotAccessWhenLoggedIn = [
        '/user/login',
        '/user/register',
    ];
    if ($isLoggedIn && in_array($request->getPathInfo(), $pathsToDoNotAccessWhenLoggedIn, true)) {
        return $app->redirect($app['url_generator']->generate('homepage'));
    }
});
$app->get('/', 'GridAdmin\Controller::indexAction')->bind('homepage');
$app->delete('/systems/{id}', 'GridAdmin\Controller::deleteSystemAction')->bind('removeSystemById');
$app->get('/downloads', 'GridAdmin\Controller::downloadsAction')->bind('downloads');
$app->post('/user/roles', 'GridAdmin\Controller::rolesAction')->bind('user.roles');

return $app;